install 47 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040104110421043104410451046104710481049105010511052105310541055105610571058105910601061106210631064106510661067106810691070107110721073107410751076107710781079108010811082108310841085108610871088108910901091109210931094109510961097109810991100110111021103110411051106110711081109111011111112111311141115111611171118111911201121112211231124112511261127112811291130113111321133113411351136113711381139114011411142114311441145114611471148114911501151115211531154115511561157115811591160116111621163116411651166116711681169117011711172117311741175117611771178117911801181118211831184118511861187118811891190119111921193119411951196119711981199120012011202120312041205120612071208120912101211121212131214121512161217121812191220122112221223122412251226122712281229123012311232123312341235123612371238123912401241124212431244124512461247124812491250125112521253125412551256125712581259126012611262126312641265126612671268126912701271127212731274127512761277127812791280128112821283128412851286128712881289129012911292129312941295129612971298129913001301130213031304130513061307130813091310131113121313131413151316131713181319132013211322132313241325132613271328132913301331133213331334133513361337133813391340134113421343134413451346134713481349135013511352135313541355135613571358135913601361136213631364136513661367136813691370137113721373137413751376137713781379138013811382138313841385138613871388138913901391139213931394139513961397139813991400140114021403140414051406140714081409141014111412141314141415141614171418141914201421142214231424142514261427142814291430143114321433143414351436143714381439144014411442144314441445144614471448144914501451145214531454145514561457145814591460146114621463146414651466146714681469147014711472147314741475147614771478
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # comprobarError exitNum codeNum extraInfo
  12. # 1xx: Servidor Web
  13. # 2xx: Base de Datos
  14. # 3xx: PHP
  15. # 4xx: SSL/TLS
  16. # 5xx: MediaWiki
  17. # 6xx: Moodle
  18. # 7xx: Actualizaciones automáticas
  19. # 8xx: Dependencias
  20. # 9xx: Servicios & Firewall
  21. type="ERROR"
  22. exitNum=$1
  23. shift
  24. codeNum=$1
  25. shift
  26. extraInfo=$@
  27. case $codeNum in
  28. 1)
  29. error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
  30. ;;
  31. 2)
  32. error="$type $codeNum:\tError interno (selección express).\n"
  33. ;;
  34. 3)
  35. error="$type $codeNum:\tError interno (selección avanzada).\n"
  36. ;;
  37. 4)
  38. error="\n$type $codeNum:\tEl archivo '"$(realpath $extraInfo)"' no existe.\n"
  39. ;;
  40. 5)
  41. error="\n$type $codeNum:\tEl directorio '"$(realpath $extraInfo)"' no existe.\n"
  42. ;;
  43. 6)
  44. error="$type $codeNum:\tError interno (selección SSL/TLS).\n"
  45. ;;
  46. 100)
  47. error="$type $codeNum:\tError interno (selección del servidor web).\n"
  48. ;;
  49. 101)
  50. error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
  51. ;;
  52. 102)
  53. error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
  54. ;;
  55. 103)
  56. error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
  57. ;;
  58. 104)
  59. error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
  60. ;;
  61. 105)
  62. error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
  63. ;;
  64. 106)
  65. type="WARNING"
  66. error="\n$type $codeNum:\tImposible instalar 'info.php'.\n"
  67. ;;
  68. 107)
  69. error="\n$type $codeNum:\tError al configurar Nginx.\n"
  70. ;;
  71. 108)
  72. error="\n$type $codeNum:\tError al configurar Apache2.\n"
  73. ;;
  74. 200)
  75. error="$type $codeNum:\tError interno (selección de base de datos).\n"
  76. ;;
  77. 201)
  78. error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
  79. ;;
  80. 202)
  81. error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
  82. ;;
  83. 203)
  84. error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
  85. ;;
  86. 204)
  87. error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
  88. ;;
  89. 205)
  90. error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
  91. ;;
  92. 206)
  93. type="WARNING"
  94. error="\n$type $codeNum:\tUsuario 'root' ya dispone de contraseña."
  95. ;;
  96. 207)
  97. error="\n$type $codeNum:\tImposible cambiar la contraseña de 'root'."
  98. ;;
  99. 208)
  100. error="\n$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior."
  101. ;;
  102. 209)
  103. error="\n$type $codeNum:\tImposible eliminar usuarios anónimos."
  104. ;;
  105. 210)
  106. type="WARNING"
  107. error="\n$type $codeNum:\tImposible eliminar bases de datos de pruebas."
  108. ;;
  109. 211)
  110. type="WARNING"
  111. error="\n$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas."
  112. ;;
  113. 212)
  114. error="\n$type $codeNum:\tImposible recargar base de datos."
  115. ;;
  116. 300)
  117. error="\n$type $codeNum:\tError interno (instalación PHP-7.2).\n"
  118. ;;
  119. 301)
  120. error="\n$type $codeNum:\tError interno (Web Server no seleccionado).\n"
  121. ;;
  122. 302)
  123. error="\n$type $codeNum:\tError al instalar PHP-7.2.\nDetalles:\n$extraInfo\n"
  124. ;;
  125. 303)
  126. error="\n$type $codeNum:\tError al instalar Repositorio Remi.\nDetalles:\n$extraInfo\n"
  127. ;;
  128. 304)
  129. error="\n$type $codeNum:\tSistema Operativo no compatible con PHP-7.2 ($OS $DIST $REV).\n"
  130. ;;
  131. 305)
  132. error="\n$type $codeNum:\tImposible configurar PHP-7.2.\n"
  133. ;;
  134. 501)
  135. error="\n$type $codeNum:\tImposible descargar MediaWiki-1.31.0.\n"
  136. ;;
  137. 502)
  138. error="\n$type $codeNum:\tImposible configurar MediaWiki-1.31.0.\n"
  139. ;;
  140. 503)
  141. error="\n$type $codeNum:\tImposible configurar Base de Datos para MediaWiki-1.31.0.\n"
  142. ;;
  143. 601)
  144. error="\n$type $codeNum:\tImposible descargar Moodle-3.5.1.\n"
  145. ;;
  146. 800)
  147. error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
  148. ;;
  149. 801)
  150. error="$type $codeNum:\t'whiptail' no instalado.\n"
  151. ;;
  152. 802)
  153. error="$type $codeNum:\t'hostnamectl' no instalado.\n"
  154. ;;
  155. 803)
  156. error="$type $codeNum:\t'apt-get' no instalado.\n"
  157. ;;
  158. 804)
  159. error="$type $codeNum:\t'yum' no instalado.\n"
  160. ;;
  161. 805)
  162. error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
  163. ;;
  164. 806)
  165. error="$type $codeNum:\t'ufw' no instalado.\n"
  166. ;;
  167. 807)
  168. error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
  169. ;;
  170. 808)
  171. error="$type $codeNum:\t'tput' no instalado.\nDetalles:\n$extraInfo\n"
  172. ;;
  173. 809)
  174. error="$type $codeNum:\t'sed' no instalado.\nDetalles:\n$extraInfo\n"
  175. ;;
  176. 810)
  177. error="$type $codeNum:\t'curl' no instalado.\nDetalles:\n$extraInfo\n"
  178. ;;
  179. 811)
  180. error="$type $codeNum:\t'tar' no instalado.\nDetalles:\n$extraInfo\n"
  181. ;;
  182. 812)
  183. error="$type $codeNum:\t'gzip' no instalado.\nDetalles:\n$extraInfo\n"
  184. ;;
  185. 813)
  186. error="$type $codeNum:\t'bzip2' no instalado.\nDetalles:\n$extraInfo\n"
  187. ;;
  188. 814)
  189. error="$type $codeNum:\t'xz' no instalado.\nDetalles:\n$extraInfo\n"
  190. ;;
  191. 815)
  192. error="$type $codeNum:\t'openssl' no instalado.\nDetalles:\n$extraInfo\n"
  193. ;;
  194. 816)
  195. error="$type $codeNum:\t'find' no instalado.\n"
  196. ;;
  197. 900)
  198. error="$type $codeNum:\tError interno (habilitar servicio).\n"
  199. ;;
  200. 901)
  201. error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
  202. ;;
  203. 902)
  204. error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
  205. ;;
  206. 903)
  207. error="$type $codeNum:\tError interno (deshabilitar servicio).\n"
  208. ;;
  209. 904)
  210. error="$type $codeNum:\tImposible parar servicio '$extraInfo'.\n"
  211. ;;
  212. 905)
  213. error="$type $codeNum:\tImposible deshabilitar servicio '$extraInfo' durante el arranque.\n"
  214. ;;
  215. 906)
  216. type="WARNING"
  217. error="\n$type $codeNum:\tImposible añadir regla al cortafuegos ('$extraInfo').\n"
  218. ;;
  219. 907)
  220. type="WARNING"
  221. error="\n$type $codeNum:\tImposible encender cortafuegos.\n"
  222. ;;
  223. 908)
  224. error="\n$type $codeNum:\tError interno (instalar Virtual Host).\n"
  225. ;;
  226. 909)
  227. error="\n$type $codeNum:\tVirtual Host '$extraInfo' no existe.\n"
  228. ;;
  229. 910)
  230. error="\n$type $codeNum:\tImposible copiar Virtual Host '$extraInfo'.\n"
  231. ;;
  232. 911)
  233. error="\n$type $codeNum:\tImposible activar Virtual Host '$extraInfo'.\n"
  234. ;;
  235. 912)
  236. error="\n$type $codeNum:\tError interno (recargar servicio).\n"
  237. ;;
  238. 913)
  239. error="\n$type $codeNum:\tImposible recargar servicio '$extraInfo'.\n"
  240. ;;
  241. *)
  242. error="ERROR 13:\tError interno (comprobación de errores)\n"
  243. exitNum=1
  244. codeNum=13
  245. ;;
  246. esac
  247. if [ $exitNum -ne 0 ];then
  248. echo -en "$error" | tee -a $logFile
  249. if [ $type = "ERROR" ];then
  250. exit $codeNum
  251. fi
  252. fi
  253. unset error exitNum codeNum type
  254. }
  255. OSInfo() {
  256. echo -en "Detectando SO..." >> $logFile
  257. OS=$(uname -s)
  258. if [ $OS = "Linux" ]; then
  259. OS="GNU/Linux"
  260. if [ -f /etc/os-release ]; then
  261. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  262. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  263. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  264. VERSION=$(grep ^VERSION_ID= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  265. for i in $ID_LIKE; do
  266. #echo -en "$i\n"
  267. case $i in
  268. debian|ubuntu)
  269. debianOS=true
  270. break
  271. ;;
  272. rhel|fedora)
  273. rhelOS=true
  274. break
  275. ;;
  276. *)
  277. debianOS=false
  278. rhelOS=false
  279. ;;
  280. esac
  281. done
  282. elif [ -f /etc/debian-version ]; then
  283. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  284. DIST="Debian"
  285. REV=""
  286. ID_LIKE="debian"
  287. VERSION=""
  288. debianOS=true
  289. elif [ -f /etc/redhat-release ]; then
  290. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  291. DIST="Red-Hat"
  292. REV=""
  293. ID_LIKE="rhel"
  294. VERSION=""
  295. rhelOS=true
  296. else
  297. # Other Linux (No Soportado)
  298. DIST=""
  299. REV=""
  300. ID_LIKE=""
  301. VERSION=""
  302. fi
  303. else
  304. # UNIX, OS X, ... (No Soportado)
  305. DIST=$OS
  306. REV=""
  307. ID_LIKE=""
  308. VERSION=""
  309. fi
  310. echo -en " $OS $DIST $REV\n" >> $logFile
  311. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  312. echo -en "$HDInfo\n" >> $logFile
  313. }
  314. comprobarRoot() {
  315. comprobarError $(id -u) 800
  316. }
  317. comprobarDependencias() {
  318. # Comprobamos whiptail
  319. which whiptail > /dev/null 2>&1
  320. comprobarError $? 801
  321. # Comprobamos hostnamectl
  322. which hostnamectl > /dev/null 2>&1
  323. comprobarError $? 802
  324. which find > /dev/null 2>&1
  325. comprobarError $? 816
  326. if [ $debianOS = true ];then
  327. # Comprobamos apt-get
  328. which apt-get > /dev/null 2>&1
  329. comprobarError $? 803
  330. # Actualizamos base de datos del repositorio
  331. echo -en "Actualizando repositorio APT..." | tee -a $logFile
  332. result=$(apt-get -q -y update 2>&1)
  333. comprobarError $? 805 $result
  334. echo -en " OK.\n" | tee -a $logFile
  335. # Comprobamos Firewall (ufw)
  336. which ufw > /dev/null 2>&1
  337. comprobarError $? 806
  338. # Comprobamos tput
  339. which tput > /dev/null 2>&1
  340. if [ $? -ne 0 ];then
  341. result=$(apt-get -q -y ncurses-bin 2>&1)
  342. comprobarError $? 808 $result
  343. fi
  344. # Comprobar sed
  345. which sed > /dev/null 2>&1
  346. if [ $? -ne 0 ];then
  347. result=$(apt-get -q -y sed 2>&1)
  348. comprobarError $? 809 $result
  349. fi
  350. # Comprobar curl
  351. which curl > /dev/null 2>&1
  352. if [ $? -ne 0 ];then
  353. result=$(apt-get -q -y curl 2>&1)
  354. comprobarError $? 810 $result
  355. fi
  356. # Comprobamos tar, gzip, bzip2 y xz
  357. which tar > /dev/null 2>&1
  358. if [ $? -ne 0 ];then
  359. result=$(apt-get -q -y install tar 2>&1)
  360. comprobarError $? 811 $result
  361. fi
  362. which gzip > /dev/null 2>&1
  363. if [ $? -ne 0 ];then
  364. result=$(apt-get -q -y install gzip 2>&1)
  365. comprobarError $? 812 $result
  366. fi
  367. which bzip2 > /dev/null 2>&1
  368. if [ $? -ne 0 ];then
  369. result=$(apt-get -q -y install bzip2 2>&1)
  370. comprobarError $? 813 $result
  371. fi
  372. which xz > /dev/null 2>&1
  373. if [ $? -ne 0 ];then
  374. result=$(apt-get -q -y install xz-utils 2>&1)
  375. comprobarError $? 814 $result
  376. fi
  377. which openssl > /dev/null 2>&1
  378. if [ $? -ne 0 ];then
  379. result=$(apt-get -q -y install openssl 2>&1)
  380. comprobarError $? 815 $result
  381. fi
  382. fi
  383. if [ $rhelOS = true ]; then
  384. # Comprobamos yum
  385. which yum > /dev/null 2>&1
  386. comprobarError $? 804
  387. # Actualizamos base de datos del repositorio
  388. echo -en "Actualizando repositorio YUM..." | tee -a $logFile
  389. result=$(yum -y makecache 2>&1)
  390. comprobarError $? 805 $result
  391. echo -en " OK.\n" | tee -a $logFile
  392. # Comprobamos Firewall (firewall-cmd)
  393. which firewall-cmd > /dev/null 2>&1
  394. comprobarError $? 807
  395. # Comprobamos tput
  396. which tput > /dev/null 2>&1
  397. if [ $? -ne 0 ];then
  398. result=$(yum -y ncurses 2>&1)
  399. comprobarError $? 808 $result
  400. fi
  401. # Comprobar sed
  402. which sed > /dev/null 2>&1
  403. if [ $? -ne 0 ];then
  404. result=$(yum -y sed 2>&1)
  405. comprobarError $? 809 $result
  406. fi
  407. # Comprobar curl
  408. which curl > /dev/null 2>&1
  409. if [ $? -ne 0 ];then
  410. result=$(yum -y curl 2>&1)
  411. comprobarError $? 810 $result
  412. fi
  413. # Comprobamos tar, gzip, bzip2 y xz
  414. which tar > /dev/null 2>&1
  415. if [ $? -ne 0 ];then
  416. result=$(yum -y install tar 2>&1)
  417. comprobarError $? 811 $result
  418. fi
  419. which gzip > /dev/null 2>&1
  420. if [ $? -ne 0 ];then
  421. result=$(yum -y install gzip 2>&1)
  422. comprobarError $? 812 $result
  423. fi
  424. which bzip2 > /dev/null 2>&1
  425. if [ $? -ne 0 ];then
  426. result=$(yum -y install bzip2 2>&1)
  427. comprobarError $? 813 $result
  428. fi
  429. which xz > /dev/null 2>&1
  430. if [ $? -ne 0 ];then
  431. result=$(yum -y install xz 2>&1)
  432. comprobarError $? 814 $result
  433. fi
  434. which openssl > /dev/null 2>&1
  435. if [ $? -ne 0 ];then
  436. result=$(yum -y install openssl 2>&1)
  437. comprobarError $? 815 $result
  438. fi
  439. fi
  440. }
  441. inicializarVariables() {
  442. debianOS=false
  443. rhelOS=false
  444. apacheOn=false
  445. nginxOn=false
  446. mySQLOn=false
  447. mariaDBOn=false
  448. phpOn=false
  449. sslOn=false
  450. letsEncryptOn=false
  451. mediaWikiOn=false
  452. moodleOn=false
  453. infoPHPOn=false
  454. actualizacionesOn=false
  455. progreso=0
  456. progresoTotal=0
  457. hostname=""
  458. logFile="./."$(basename $0)".log"
  459. maxUpload="100M"
  460. webServerName=""
  461. webServerUser=""
  462. webServerGroup=""
  463. sqlServerName=""
  464. phpFPMName=""
  465. dominioMediaWiki=""
  466. }
  467. instalacionExpress() {
  468. apacheOn=true
  469. mariaDBOn=true
  470. phpOn=true
  471. sslOn=true
  472. letsEncryptOn=true
  473. mediaWikiOn=true
  474. moodleOn=true
  475. actualizacionesOn=true
  476. progresoTotal=15
  477. # Preguntas mínimas
  478. establecerFQDN
  479. leerSQLPasswd
  480. mostrarMediaWiki
  481. }
  482. mostrarBienvenida() {
  483. ANCHO=$(tput cols)
  484. ALTO=$(tput lines)
  485. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  486. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Salir"
  487. exit 1
  488. fi
  489. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  490. comprobarError $? 1
  491. }
  492. mostrarExpress() {
  493. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  494. "Express" "Instalación rápida" ON \
  495. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  496. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  497. comprobarError $? 1
  498. case $express in
  499. Express)
  500. instalacionExpress
  501. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  502. ;;
  503. Avanzada)
  504. mostrarAvanzada
  505. ;;
  506. *)
  507. comprobarError 1 2
  508. ;;
  509. esac
  510. unset express
  511. }
  512. mostrarAvanzada() {
  513. webServer=$(whiptail --title "INSTALACION AVANZADA" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de Servidor Web que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  514. "LAMP" "GNU/Linux + Apache + MySQL/MariaDB + PHP-7" ON \
  515. "LEMP" "GNU/Linux + Nginx + MySQL/MariaDB + PHP-7" OFF \
  516. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  517. comprobarError $? 1
  518. for i in $webServer; do
  519. case $i in
  520. LAMP)
  521. apacheOn=true
  522. ;;
  523. LEMP)
  524. nginxOn=true
  525. ;;
  526. *)
  527. comprobarError 1 100
  528. ;;
  529. esac
  530. done
  531. # Opciones comunes
  532. establecerFQDN
  533. mostrarDatabase
  534. phpOn=true
  535. establecerMaxUpload
  536. progresoTotal=$((progresoTotal + 6))
  537. mostrarComponentes
  538. unset webServer
  539. }
  540. mostrarComponentes() {
  541. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 5 \
  542. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  543. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  544. "Moodle" "Instalar campus virtual con Moodle" ON \
  545. "InfoPHP" "Instalar info.php (sólo para pruebas)" OFF \
  546. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  547. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  548. comprobarError $? 1
  549. # Mejora: autodetección de componentes ya instalados
  550. for i in $componentes; do
  551. case $i in
  552. \"SSL/TLS\")
  553. # 2 Opciones: Let's Encrypt o Autofirmado
  554. mostrarSSL
  555. progresoTotal=$((progresoTotal + 2))
  556. ;;
  557. \"MediaWiki\")
  558. mediaWikiOn=true
  559. mostrarMediaWiki
  560. progresoTotal=$((progresoTotal + 2))
  561. ;;
  562. \"Moodle\")
  563. moodleOn=true
  564. progresoTotal=$((progresoTotal + 2))
  565. ;;
  566. \"InfoPHP\")
  567. infoPHPOn=true
  568. progresoTotal=$((progresoTotal + 2))
  569. ;;
  570. \"Actualizaciones\")
  571. actualizacionesOn=true
  572. progresoTotal=$((progresoTotal + 1))
  573. ;;
  574. *)
  575. comprobarError 1 3
  576. ;;
  577. esac
  578. done
  579. progresoTotal=$((progresoTotal + 2))
  580. unset componentes
  581. }
  582. mostrarSSL() {
  583. ssl=$(whiptail --title "INSTALACION SSL/TLS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de Certificado SSL/TLS que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  584. "LetsEncrypt" "Compatible con todos los navegadores" ON \
  585. "Auto-Firmado" "Certificados auto-firmados (sólo para pruebas)" OFF \
  586. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  587. comprobarError $? 1
  588. for i in $ssl; do
  589. case $i in
  590. LetsEncrypt)
  591. sslOn=true
  592. letsEcnryptOn=true
  593. ;;
  594. Auto-Firmados)
  595. sslOn=true
  596. ;;
  597. *)
  598. comprobarError 1 6
  599. ;;
  600. esac
  601. done
  602. unset ssl
  603. }
  604. mostrarMediaWiki(){
  605. # Introducir nombre wiki
  606. while [ -z $nombreMediaWiki ]; do
  607. nombreMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --inputbox "Introduzca el nombre de la Wiki:." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  608. comprobarError $? 1
  609. # Mejora: comprobar si el dominio ya está en uso
  610. done
  611. # Introducir dominio
  612. while [ -z $dominioMediaWiki ]; do
  613. dominioMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --inputbox "Introduzca el dominio/subdominio de la Wiki.\nTenga en cuenta que debes apuntar este a la dirección IP de esta máquina mediante un registro DNS tipo CNAME." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) wiki.$hostname --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  614. comprobarError $? 1
  615. # Mejora: comprobar si el dominio ya está en uso
  616. done
  617. # Introducir tipo de Wiki (abierta, creación de cuenta requerida, sólo editores autorizados o wiki privada)
  618. tipoMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo de wiki que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 4 \
  619. "Abierta" "Wiki Abierta" ON \
  620. "CuentaRequerida" "Creación de cuenta requerida" OFF \
  621. "EditoresAutorizados" "Sólo editores autorizados" OFF \
  622. "Privada" "Wiki privada" OFF \
  623. --ok-button "Continuar" --cancel-button "Salir" --notags 3>&1 1>&2 2>&3)
  624. comprobarError $? 1
  625. # Introducir tipo de Licencia
  626. licenciaMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el tipo licencia para la wiki:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 3 \
  627. "Nada" "Sin Licencia" ON \
  628. "CC-BY-SA" "Creative Commons Atribución-CompartirIgual" OFF \
  629. "CC-BY-NC-SA" "Creative Commons Atribución-NoComercial-CompartirIgual" OFF \
  630. --ok-button "Continuar" --cancel-button "Salir" --notags 3>&1 1>&2 2>&3)
  631. comprobarError $? 1
  632. }
  633. establecerFQDN() {
  634. while [ -z $hostname ]; do
  635. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  636. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  637. hostnamectl set-hostname $hostname
  638. else
  639. hostname=$(hostname)
  640. fi
  641. done
  642. echo -en "Hostname: $hostname\n" >> $logFile
  643. }
  644. instalarApache() {
  645. if [ $debianOS = true ];then
  646. webServerName="apache2"
  647. result=$(apt-get -q -y install apache2 2>&1)
  648. comprobarError $? 101 $result
  649. elif [ $rhelOS = true ]; then
  650. webServerName="httpd"
  651. result=$(yum -y install httpd 2>&1)
  652. comprobarError $? 101 $result
  653. else
  654. comprobarError 1 104
  655. fi
  656. deshabilitarServicio $webServerName
  657. }
  658. configurarApache() {
  659. if [ $debianOS = true ];then
  660. apacheConfFile="./etc/$webServerName-debian/apache2.conf"
  661. if [ ! -f $apacheConfFile ];then
  662. comprobarError 1 4 $apacheConfFile
  663. fi
  664. cp -f $apacheConfFile /etc/$webServerName/apache2.conf 2>/dev/null
  665. comprobarError $? 108
  666. webServerUser=$(grep ^User /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
  667. webServerGroup=$(grep ^Group /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
  668. elif [ $rhelOS = true ];then
  669. apacheConfFile="./etc/$webServerName-rhel/conf/httpd.conf"
  670. welcomeConfFile="/etc/$webServerName/conf.d/welcome.conf"
  671. if [ ! -f $apacheConfFile ];then
  672. comprobarError 1 4 $apacheConfFile
  673. fi
  674. cp -f $apacheConfFile /etc/$webServerName/conf/ 2>/dev/null
  675. comprobarError $? 108
  676. if [ -f $welcomeConfFile ];then
  677. sed -i -e 's/^/#/' $welcomeConfFile
  678. comprobarError $? 108
  679. fi
  680. webServerUser=$(grep ^User /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
  681. webServerGroup=$(grep ^Group /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
  682. unset apacheConfFile welcomeConfFile
  683. fi
  684. if [ ! -d "/etc/$webServerName/sites-available" ];then
  685. mkdir "/etc/$webServerName/sites-available" 2>/dev/null
  686. comprobarError $? 5 "/etc/$webServerName/sites-available"
  687. fi
  688. if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
  689. mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
  690. comprobarError $? 5 "$webServerRoot/sites-enabled"
  691. fi
  692. }
  693. instalarNginx() {
  694. webServerName="nginx"
  695. if [ $debianOS = true ];then
  696. result=$(apt-get -q -y install nginx 2>&1)
  697. comprobarError $? 102 $result
  698. elif [ $rhelOS = true ]; then
  699. # Hay que instalar primero otro repositorio
  700. result=$(yum -y install epel-release)
  701. comprobarError $? 103 $result
  702. result=$(yum -y install nginx 2>&1)
  703. comprobarError $? 102 $result
  704. else
  705. comprobarError 1 105
  706. fi
  707. deshabilitarServicio $webServerName
  708. }
  709. configurarNginx() {
  710. # Configuramos Nginx
  711. rm -Rf /etc/$webServerName/* 2>/dev/null
  712. comprobarError $? 107
  713. nginxConfFile="./etc/$webServerName"
  714. if [ -d "$nginxConfFile" ];then
  715. cp -Rf $nginxConfFile/* /etc/$webServerName/ 2>/dev/null
  716. comprobarError $? 107
  717. else
  718. comprobarError 1 5 "$nginxConfFile"
  719. fi
  720. if [ ! -d "/etc/$webServerName/sites-available" ];then
  721. mkdir "/etc/$webServerName/sites-available" 2>/dev/null
  722. comprobarError $? 5 "/etc/$webServerName/sites-available"
  723. fi
  724. if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
  725. mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
  726. comprobarError $? 5 "$webServerRoot/sites-enabled"
  727. fi
  728. # Configuramos Usuario y Grupo
  729. if [ $debianOS = true ];then
  730. webServerUser="www-data"
  731. webServerGroup=$webServerUser
  732. elif [ $rhelOS = true ];then
  733. webServerUser="nginx"
  734. webServerGroup=$webServerUser
  735. fi
  736. sed -i '/user /c\user '$webServerUser';' /etc/$webServerName/nginx.conf
  737. comprobarError $? 107
  738. unset nginxConfFile
  739. }
  740. instalarVirtualHost() {
  741. # Configuramos un Virtual Host para Apache o Nginx
  742. # Uso: instalarVirtualHost $root $dominio $virtualHost
  743. webServerRoot=$(realpath "/etc/$webServerName/")
  744. if [ $# -eq 3 ];then
  745. rootVirtualHost=$(realpath $1)
  746. dominioVirtualHost=$2
  747. virtualHostFile=$(realpath $3)
  748. virtualHostName=$dominioVirtualHost".conf"
  749. else
  750. comprobarError 1 908
  751. fi
  752. if [ ! -f $virtualHostFile ];then
  753. comprobarError 1 909 $virtualHostName
  754. fi
  755. if [ $nginxOn = true ];then
  756. # Configuramos root, dominio, logs y php-fpm.sock (NGINX)
  757. sed -i '/root/c\\troot '/var/www/$dominioVirtualHost';' $virtualHostFile
  758. comprobarError $? 502
  759. sed -i '/server_name/c\\tserver_name '$dominioVirtualHost';' $virtualHostFile
  760. comprobarError $? 502
  761. sed -i '/access_log/c\\taccess_log /var/log/nginx/'$dominioVirtualHost'-access.log;' $virtualHostFile
  762. comprobarError $? 502
  763. sed -i '/error_log/c\\terror_log /var/log/nginx/'$dominioVirtualHost'-error.log;' $virtualHostFile
  764. comprobarError $? 502
  765. socket=$(find /var/run/ -type s -name 'php*.sock')
  766. sed -i '/fastcgi_pass/c\\t\tfastcgi_pass unix:'$socket';' $virtualHostFile
  767. fi
  768. # Copiamos ficheros de configuración
  769. cp -f $virtualHostFile "$webServerRoot/sites-available/$virtualHostName" >> $logFile 2>&1
  770. comprobarError $? 910
  771. ln -s "$webServerRoot/sites-available/$virtualHostName" "$webServerRoot/sites-enabled/$virtualHostName" >> $logFile 2>&1
  772. comprobarError $? 911 $virtualHostName
  773. recargarServicio $webServerName
  774. unset webServerRoot rootVirtualHost dominioVirtualHost virtualHostFile virtualHostName
  775. }
  776. mostrarDatabase() {
  777. if [ $debianOS = true ]; then
  778. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  779. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" ON \
  780. "MySQL" "Instalar la base de datos MySQL (uso no comercial)" OFF \
  781. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  782. comprobarError $? 1
  783. case $database in
  784. MariaDB)
  785. mariaDBOn=true
  786. ;;
  787. MySQL)
  788. mySQLOn=true
  789. ;;
  790. *)
  791. comprobarError 1 200
  792. ;;
  793. esac
  794. unset database
  795. elif [ $rhelOS = true ]; then
  796. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  797. comprobarError $? 1
  798. mariaDBOn=true
  799. else
  800. comprobarError 1 200
  801. fi
  802. # Otras opciones (contraseña)
  803. leerSQLPasswd
  804. }
  805. leerSQLPasswd() {
  806. control=false
  807. error=""
  808. # Leemos la contreseña (stdin) y confirmamos
  809. while [ $control = false ]; do
  810. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  811. comprobarError $? 1
  812. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  813. comprobarError $? 1
  814. #echo -en "SQL Password 1: $sqlPasswd\n"
  815. #echo -en "SQL Password 2: $sqlPasswd2\n"
  816. if [ -z $sqlPasswd ] || [ -z $sqlPasswd2 ]; then
  817. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  818. elif [ $sqlPasswd != $sqlPasswd2 ];then
  819. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  820. else
  821. control=true
  822. fi
  823. done
  824. #echo -en "SQL Password: $sqlPasswd\n"
  825. unset control error sqlPasswd2
  826. }
  827. establecerSQLPasswd() {
  828. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  829. # Comprobamos si ya tiene una contraseña asignada
  830. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  831. if [ $? -eq 0 ];then
  832. # Establecemos contraseña del usuario root (y desactivamos posibles plugins para forzar login por contraseña)
  833. mysql -e "UPDATE mysql.user SET plugin = '', Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" >> $logFile 2>&1
  834. comprobarError $? 207
  835. # Desactivamos acceso root desde el exterior (solo localhost)
  836. mysql -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" >> $logFile 2>&1
  837. comprobarError $? 208
  838. # Eliminamos todos los usuarios anónimos
  839. mysql -e "DELETE FROM mysql.user WHERE User=''" >> $logFile 2>&1
  840. comprobarError $? 209
  841. # Eliminamos bases de datos 'test'
  842. mysql -e "DROP DATABASE IF EXISTS test" >> $logFile 2>&1
  843. comprobarError $? 210
  844. # Eliminamos privilegios de la base de datos 'test'
  845. mysql -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" >> $logFile 2>&1
  846. comprobarError $? 211
  847. # Aplicamos los cambios
  848. mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
  849. comprobarError $? 212
  850. else
  851. comprobarError 1 206
  852. fi
  853. }
  854. instalarMySQL() {
  855. sqlServerName="mysql"
  856. if [ $debianOS = true ];then
  857. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  858. comprobarError $? 201 $result
  859. elif [ $rhelOS = true ];then
  860. # MySQL no disponible en RHEL. 2 opciones:
  861. # 1) Instalar un repositorio adicional
  862. # 2) No instalar MySQL en distribuciones RHEL
  863. comprobarError 1 205
  864. else
  865. comprobarError 1 203
  866. fi
  867. }
  868. instalarMariaDB() {
  869. sqlServerName="mariadb"
  870. if [ $debianOS = true ];then
  871. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  872. comprobarError $? 202 $result
  873. elif [ $rhelOS = true ];then
  874. result=$(yum -y install mariadb-server mariadb 2>&1)
  875. comprobarError $? 202 $result
  876. else
  877. comprobarError 1 204
  878. fi
  879. }
  880. instalarPHP() {
  881. # Instalamos PHP-7 de forma diferente si es junto a Apache o con Nginx
  882. if [ $debianOS = true ];then
  883. if [ $apacheOn = true ]; then
  884. result=$(apt-get -q -y install php libapache2-mod-php php-mysql php-intl php-mbstring php-xml php-apcu php-gd 2>&1)
  885. comprobarError $? 302 $result
  886. elif [ $nginxOn = true ];then
  887. phpFPMName="php7.2-fpm"
  888. result=$(apt-get -q -y install php-fpm php-mysql php-intl php-mbstring php-xml php-apcu php-gd 2>&1)
  889. comprobarError $? 302 $result
  890. deshabilitarServicio $phpFPMName
  891. else
  892. comprobarError 1 301
  893. fi
  894. elif [ $rhelOS = true ];then
  895. # Necesitamos un repositorio adicional para PHP-7 (EPEL-RELEASE)
  896. result=$(yum -y install epel-release yum-utils 2>&1)
  897. comprobarError $? 103 $result
  898. # Necesitamos un repositorio adicional para PHP-7 (REMI-RELEASE)
  899. if [ ! -f /etc/yum.repos.d/remi-php72.repo ];then
  900. if [ $VERSION = "7" ];then
  901. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-7.rpm 2>&1)
  902. comprobarError $? 303 $result
  903. elif [ $VERSION = "6" ];then
  904. result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-6.rpm 2>&1)
  905. comprobarError $? 303 $result
  906. elif [ $VERSION = "28" ];then
  907. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-28.rpm 2>&1)
  908. comprobarError $? 303 $result
  909. elif [ $VERSION = "27" ];then
  910. result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-27.rpm 2>&1)
  911. comprobarError $? 303 $result
  912. else
  913. comprobarError 1 304
  914. fi
  915. fi
  916. # Activamos repositorio remi-php72
  917. result=$(yum-config-manager --enable remi-php72 2>&1)
  918. comprobarError $? 303 $result
  919. # Instalamos PHP-7.2
  920. if [ $apacheOn = true ];then
  921. result=$(yum -y install php php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd 2>&1)
  922. comprobarError $? 302 $result
  923. elif [ $nginxOn = true ];then
  924. phpFPMName="php-fpm"
  925. result=$(yum -y install php php-fpm php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd 2>&1)
  926. comprobarError $? 302 $result
  927. deshabilitarServicio $phpFPMName
  928. else
  929. comprobarError 1 301
  930. fi
  931. else
  932. comprobarError 1 300
  933. fi
  934. }
  935. configurarPHP() {
  936. # Configura PHP para segurizarlo y establecer máximo de subida.
  937. if [ $debianOS = true ];then
  938. phpConfFile="./etc/php/php.ini.debian"
  939. phpDest="/etc/php/7.2/cli/php.ini"
  940. elif [ $rhelOS = true ];then
  941. phpConfFile="./etc/php/php.ini.rhel"
  942. phpDest="/etc/php.ini"
  943. fi
  944. if [ ! -f $phpConfFile ];then
  945. comprobarError 1 4 "$phpConfFile"
  946. fi
  947. # Copiamos configuración
  948. cp -f $phpConfFile $phpDest 2>/dev/null
  949. comprobarError $? 305
  950. # Configuramos cgi.fix_pathinfo
  951. sed -i '/cgi.fix_pathinfo=/c\cgi.fix_pathinfo=0' $phpDest
  952. comprobarError $? 305
  953. # Configuramos post_max_size
  954. sed -i '/post_max_size =/c\post_max_size = '$maxUpload $phpDest
  955. comprobarError $? 305
  956. # Configuramos upload_max_filesize
  957. sed -i '/upload_max_filesize =/c\upload_max_filesize = '$maxUpload $phpDest
  958. comprobarError $? 305
  959. # Configurar php-fpm (sólo en RHEL con Nginx)
  960. if [ $rhelOS = true ] && [ $nginxOn = true ];then
  961. # Configurar Socket UNIX
  962. phpConfFile="./etc/php/php-fpm.d/www.conf"
  963. phpDest="/etc/php-fpm.d/www.conf"
  964. if [ ! -f $phpConfFile ];then
  965. comprobarError $? 4 "$phpConfFile"
  966. fi
  967. cp -f $phpConfFile $phpDest 2>/dev/null
  968. comprobarError $? 305
  969. # Configurar Permisos /var/lib/php
  970. chown -R $webServerUser:$webServerGroup /var/lib/php/
  971. comprobarError $? 305
  972. fi
  973. unset phpConfFile phpDest
  974. }
  975. establecerMaxUpload() {
  976. control=false
  977. error=""
  978. while [ $control = false ];do
  979. maxUpload2=$(whiptail --title "PHP MAX UPLOAD" --inputbox "$error""Introduzca el tamaño máximo permitido de los ficheros subidos al servidor:\n(<K:Kilobyte> <M:Megabyte> <G:Gigabyte>)" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) $maxUpload --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  980. comprobarError $? 1
  981. if [ -z $maxUpload2 ];then
  982. error="ERROR: NO PUEDES DEJAR ESTE PARÁMETRO VACIO.\n"
  983. else
  984. control=true
  985. fi
  986. done
  987. maxUpload=$maxUpload2
  988. unset control maxUpload2
  989. }
  990. instalarPHPInfo() {
  991. # Instalar fichero php
  992. if [ ! -f /etc/$webServerName/sites-enabled/phpinfo.conf ];then
  993. infoFile="./var/www/info.php"
  994. if [ ! -f $infoFile ];then
  995. comprobarError 1 4 "$infoFile"
  996. fi
  997. cp -f $infoFile /var/www/html/ 2>/dev/null
  998. comprobarError $? 106
  999. chown -R $webServerUser:$webServerGroup /var/www/html 2>/dev/null
  1000. comprobarError $? 106
  1001. unset infoFile
  1002. # Instalar VirtualHost
  1003. virtualHost="./etc/$webServerName/sites-available/phpinfo.conf"
  1004. instalarVirtualHost "/var/www/html" "localhost" $virtualHost
  1005. unset virtualHost
  1006. return 0
  1007. else
  1008. return 1
  1009. fi
  1010. }
  1011. habilitarServicio() {
  1012. # Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
  1013. # Intentamos con systemctl (SystemD)
  1014. #echo -en "Habilitando Servicio '$1'" | tee -a $logFile
  1015. if [ $# -le 0 ];then
  1016. comprobarError 1 900
  1017. fi
  1018. which systemctl > /dev/null 2>&1
  1019. if [ $? -eq 0 ]; then
  1020. #echo -en " (SystemD)..." | tee -a $logFile
  1021. systemctl start $1 > /dev/null 2>&1
  1022. comprobarError $? 901 $1
  1023. systemctl enable $1 > /dev/null 2>&1
  1024. comprobarError $? 902 $1
  1025. else
  1026. # Intentamos con service (Upstart)
  1027. which service > /dev/null 2>&1
  1028. if [ $? -eq 0 ]; then
  1029. #echo -en " (Upstart)..." | tee -a $logFile
  1030. service $1 start > /dev/null 2>&1
  1031. comprobarError $? 901 $1
  1032. else
  1033. # Intentamos con init.d (SystemV)
  1034. #echo -en " (SystemV)..." | tee -a $logFile
  1035. /etc/init.d/$1 start > /dev/null 2>&1
  1036. comprobarError $? 901 $1
  1037. fi
  1038. # Intentamos habilitar en el arranque (Upstart)
  1039. which update-rc.d > /dev/null 2>&1
  1040. if [ $? -eq 0 ];then
  1041. update-rc.d $1 enable
  1042. comprobarError $? 902 $1
  1043. else
  1044. # Intentamos habilitar en el arranque (SystemV)
  1045. which chkconfig > /dev/null 2>&1
  1046. if [ $? -eq 0 ];then
  1047. chkconfig $1 on
  1048. comprobarError $? 902 $1
  1049. else
  1050. # ¿Qué mas opciones nos quedan?
  1051. comprobarError 1 902 $1
  1052. fi
  1053. fi
  1054. fi
  1055. # Mejora: comprobar si el servicio está parado
  1056. #echo -en " OK.\n" | tee -a $logFile
  1057. }
  1058. deshabilitarServicio() {
  1059. # Paramos y deshabilitamos el servicio (con SystemD, Upstart o SystemV)
  1060. # Intentamos con systemctl (SystemD)
  1061. #echo -en "Deshabilitando Servicio '$1'" | tee -a $logFile
  1062. if [ $# -le 0 ];then
  1063. comprobarError 1 903
  1064. fi
  1065. which systemctl > /dev/null 2>&1
  1066. if [ $? -eq 0 ]; then
  1067. #echo -en " (SystemD)..." | tee -a $logFile
  1068. systemctl stop $1 > /dev/null 2>&1
  1069. comprobarError $? 904 $1
  1070. systemctl disable $1 > /dev/null 2>&1
  1071. comprobarError $? 905 $1
  1072. else
  1073. # Intentamos con service (Upstart)
  1074. which service > /dev/null 2>&1
  1075. if [ $? -eq 0 ]; then
  1076. #echo -en " (Upstart)..." | tee -a $logFile
  1077. service $1 stop > /dev/null 2>&1
  1078. comprobarError $? 904 $1
  1079. else
  1080. # Intentamos con init.d (SystemV)
  1081. #echo -en " (SystemV)..." | tee -a $logFile
  1082. /etc/init.d/$1 stop > /dev/null 2>&1
  1083. comprobarError $? 904 $1
  1084. fi
  1085. # Intentamos habilitar en el arranque (Upstart)
  1086. which update-rc.d > /dev/null 2>&1
  1087. if [ $? -eq 0 ];then
  1088. update-rc.d $1 disable
  1089. comprobarError $? 905 $1
  1090. else
  1091. # Intentamos habilitar en el arranque (SystemV)
  1092. which chkconfig > /dev/null 2>&1
  1093. if [ $? -eq 0 ];then
  1094. chkconfig $1 off
  1095. comprobarError $? 905 $1
  1096. else
  1097. # ¿Qué mas opciones nos quedan?
  1098. comprobarError 1 905 $1
  1099. fi
  1100. fi
  1101. fi
  1102. # Mejora: comprobar si el servicio está funcionando
  1103. #echo -en " OK.\n" | tee -a $logFile
  1104. }
  1105. recargarServicio() {
  1106. # Recargamos el servicio (con SystemD, Upstart o SystemV)
  1107. # Intentamos con systemctl (SystemD)
  1108. #echo -en "Recargando Servicio '$1'" | tee -a $logFile
  1109. if [ $# -le 0 ];then
  1110. comprobarError 1 912
  1111. fi
  1112. which systemctl > /dev/null 2>&1
  1113. if [ $? -eq 0 ]; then
  1114. #echo -en " (SystemD)..." | tee -a $logFile
  1115. systemctl reload $1 > /dev/null 2>&1
  1116. comprobarError $? 913 $1
  1117. else
  1118. # Intentamos con service (Upstart)
  1119. which service > /dev/null 2>&1
  1120. if [ $? -eq 0 ]; then
  1121. #echo -en " (Upstart)..." | tee -a $logFile
  1122. service $1 reload > /dev/null 2>&1
  1123. comprobarError $? 913 $1
  1124. else
  1125. # Intentamos con init.d (SystemV)
  1126. #echo -en " (SystemV)..." | tee -a $logFile
  1127. /etc/init.d/$1 reload > /dev/null 2>&1
  1128. comprobarError $? 913 $1
  1129. fi
  1130. fi
  1131. # Mejora: comprobar si el servicio está funcionando
  1132. #echo -en " OK.\n" | tee -a $logFile
  1133. }
  1134. configurarCortafuegos() {
  1135. # Configuramos cortafuegos (añadir reglas y encender)
  1136. # Comprobamos si estamos usando SSH
  1137. esSSH $PPID
  1138. if [ $debianOS = true ];then
  1139. ufw allow 80/tcp >> $logFile 2>&1
  1140. comprobarError $? 906 "80/tcp"
  1141. if [ $sshControl = true ];then
  1142. ufw allow 22/tcp >> $logFile 2>&1
  1143. comprobarError $? 906 "22/tcp"
  1144. fi
  1145. if [ $sslOn = true ];then
  1146. ufw allow 443/tcp >> $logFile 2>&1
  1147. comprobarError $? 906 "443/tcp"
  1148. fi
  1149. ufw --force enable >> $logFile 2>&1
  1150. comprobarError $? 907
  1151. elif [ $rhelOS = true ];then
  1152. firewall-cmd --add-port=80/tcp >> $logFile 2>&1
  1153. comprobarError $? 906 "80/tcp"
  1154. if [ $sshControl = true ];then
  1155. firewall-cmd --add-port=22/tcp >> $logFile 2>&1
  1156. comprobarError $? 906 "22/tcp"
  1157. fi
  1158. if [ $sslOn = true ];then
  1159. firewall-cmd --add-port=443/tcp >> $logFile 2>&1
  1160. comprobarError $? 906 "443/tcp"
  1161. fi
  1162. firewall-cmd --runtime-to-permanent >> $logFile 2>&1
  1163. comprobarError $? 907
  1164. habilitarServicio firewalld >> $logFile 2>&1
  1165. comprobarError $? 907
  1166. fi
  1167. unset sshControl
  1168. }
  1169. esSSH() {
  1170. p=${1:-$PPID}
  1171. #read pid name x ppid y < <( cat /proc/$p/stat )
  1172. read pid name ppid < <( ps -o pid= -o comm= -o ppid= -p $p)
  1173. [[ "$name" =~ sshd ]] && { sshControl=true; return 0; }
  1174. [ "$ppid" -le 1 ] && { sshControl=false; return 1; }
  1175. esSSH $ppid
  1176. }
  1177. descargarMediaWiki() {
  1178. # Descargar la versión 1.31.0 de MediaWiki
  1179. if [ ! -d ./var ];then
  1180. comprobarError 1 5 "./var"
  1181. fi
  1182. #echo -en "Descargando MediaWiki-1.31.0..." | tee -a $logFile
  1183. #curl -o "./var/mediawiki-1.31.0.tar.gz" "https://releases.wikimedia.org/mediawiki/1.31/mediawiki-1.31.0.tar.gz" >> $logFile 2>&1
  1184. curl "https://releases.wikimedia.org/mediawiki/1.31/mediawiki-1.31.0.tar.gz" 2>$logFile | tar -xz -C "./var/"
  1185. comprobarError $? 501
  1186. #echo -en " Ok.\n" | tee -a $logFile
  1187. }
  1188. configurarMediaWiki() {
  1189. # Configuramos MediaWiki
  1190. # Copiamos archivos y permisos
  1191. cp -R ./var/mediawiki-1.31.0/ /var/www/$dominioMediaWiki
  1192. comprobarError $? 502
  1193. chown -R $webServerUser:$webServerGroup /var/www/$dominioMediaWiki
  1194. comprobarError $? 502
  1195. # Creamos DataBase
  1196. crearDBMediaWiki
  1197. # Configuramos LocalSettings.php
  1198. # Configuramos VirtualHost
  1199. if [ $nginxOn = true ];then
  1200. if [ $sslOn = true ];then
  1201. virtualHost="./etc/nginx/sites-available/mediawiki-ssl.conf"
  1202. else
  1203. virtualHost="./etc/nginx/sites-available/mediawiki.conf"
  1204. fi
  1205. if [ ! -f $virtualHost ];then
  1206. comprobarError $? 502
  1207. fi
  1208. comprobarError $? 502
  1209. fi
  1210. instalarVirtualHost "/etc/$webServerName/" $dominioMediaWiki $virtualHost
  1211. unset virtualHost socket
  1212. }
  1213. crearDBMediaWiki() {
  1214. # Creamos una base de datos para MediaWiki
  1215. dbDir="./etc/db"
  1216. if [ ! -d $dbDir ];then
  1217. mkdir $dbDir 2>/dev/null
  1218. comprobarError $? 503
  1219. fi
  1220. dbFile=$dbDir"/mediawiki.sql"
  1221. nombreDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
  1222. userDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
  1223. echo -en "CREATE DATABASE IF NOT EXISTS $nombreDBMW;\n" > $dbFile
  1224. echo -en "GRANT ALL PRIVILEGES ON $nombreDBMW.* TO '$userDBMW'@'localhost' IDENTIFIED BY '$sqlPasswd';\n" >> $dbFile
  1225. mysql -u root --password=$sqlPasswd < $dbFile
  1226. control=$?
  1227. rm -f $dbFile 2>/dev/null
  1228. comprobarError $? 503
  1229. comprobarError $control 503
  1230. unset control
  1231. }
  1232. descargarMoodle() {
  1233. # Descargar la versión 1.31.0 de MediaWiki
  1234. if [ ! -d ./var ];then
  1235. comprobarError 1 5 "./var"
  1236. fi
  1237. #echo -en "Descargando Moodle-3.5-1..." | tee -a $logFile
  1238. #curl -o "./var/moodle-3.5.1.tgz" "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" >> $logFile 2>&1
  1239. curl "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" 2>$logFile | tar -xz -C "./var/"
  1240. comprobarError $? 501
  1241. #echo -en " OK.\n" | tee -a $logFile
  1242. }
  1243. # Comprobación del sistema e inicialización
  1244. inicializarVariables
  1245. comprobarRoot
  1246. OSInfo
  1247. comprobarDependencias
  1248. # Bienvenida
  1249. mostrarBienvenida
  1250. # Selección de componentes (express vs avanzada)
  1251. mostrarExpress
  1252. # Instalación Servidor Web
  1253. if [ $apacheOn = true ]; then
  1254. echo -en "Instalando Servidor Web Apache..." | tee -a $logFile
  1255. # {
  1256. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1257. instalarApache
  1258. progreso=$((progreso + 1))
  1259. # } > >(whiptail --gauge "Instalando Web Server Apache..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1260. echo -en " OK.\n" | tee -a $logFile
  1261. elif [ $nginxOn = true ]; then
  1262. echo -en "Instalando Servidor Web Nginx..." | tee -a $logFile
  1263. # {
  1264. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1265. instalarNginx
  1266. progreso=$((progreso + 1))
  1267. # } > >(whiptail --gauge "Instalando Web Server Nginx..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1268. echo -en " OK.\n" | tee -a $logFile
  1269. fi
  1270. # Instalación Base de Datos
  1271. if [ $mySQLOn = true ]; then
  1272. echo -en "Instalando Base de Datos MySQL..." | tee -a $logFile
  1273. # {
  1274. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1275. instalarMySQL
  1276. progreso=$((progreso + 1))
  1277. # } > >(whiptail --gauge "Instalando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1278. echo -en " OK.\n" | tee -a $logFile
  1279. elif [ $mariaDBOn = true ]; then
  1280. echo -en "Instalando Base de Datos MariaDB..." | tee -a $logFile
  1281. # {
  1282. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1283. instalarMariaDB
  1284. progreso=$((progreso + 1))
  1285. # } > >(whiptail --gauge "Instalando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1286. echo -en " OK.\n" | tee -a $logFile
  1287. fi
  1288. # Instalación PHP-7.2
  1289. if [ $phpOn = true ]; then
  1290. echo -en "Instalando PHP-7..." | tee -a $logFile
  1291. # {
  1292. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1293. instalarPHP
  1294. progreso=$((progreso + 1))
  1295. # } > >(whiptail --gauge "Instalando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1296. echo -en " OK.\n" | tee -a $logFile
  1297. fi
  1298. # Instalación SSL/TLS
  1299. if [ $sslOn = true ];then
  1300. echo -en "Instalando SSL/TLS..." | tee -a $logfile
  1301. # {
  1302. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1303. sleep 2
  1304. progreso=$((progreso + 1))
  1305. # } > >(whiptail --gauge "Instalando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1306. echo -en " OK.\n" | tee -a $logFile
  1307. fi
  1308. # Configuración Web Server
  1309. if [ $apacheOn = true ];then
  1310. echo -en "Configurando Servidor Web Apache..." | tee -a $logFile
  1311. # {
  1312. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1313. configurarApache
  1314. progreso=$((progreso + 1))
  1315. # } > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1316. echo -en " OK.\n" | tee -a $logFile
  1317. elif [ $nginxOn = true ]; then
  1318. echo -en "Configurando Servidor Web Nginx..." | tee -a $logFile
  1319. # {
  1320. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1321. configurarNginx
  1322. progreso=$((progreso + 1))
  1323. # } > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1324. echo -en " OK.\n" | tee -a $logFile
  1325. fi
  1326. # Configuración Database (Arrancar Base de Datos, establecer contraseña y configuración segura)
  1327. if [ $mySQLOn = true ] || [ $mariaDBOn = true ];then
  1328. habilitarServicio "$sqlServerName"
  1329. echo -en "Configurando Base de Datos MySQL..." | tee -a $logFile
  1330. # {
  1331. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1332. establecerSQLPasswd
  1333. progreso=$((progreso + 1))
  1334. # } > >(whiptail --gauge "Configurando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1335. echo -en " OK.\n" | tee -a $logFile
  1336. fi
  1337. # Configuración PHP (cgi.fix_pathinfo=0 y Configurar máximo de subida de archivos)
  1338. if [ $phpOn = true ];then
  1339. echo -en "Configurando PHP-7..." | tee -a $logFile
  1340. # {
  1341. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1342. configurarPHP
  1343. progreso=$((progreso + 1))
  1344. # } > >(whiptail --gauge "Configurando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1345. echo -en " OK.\n" | tee -a $logFile
  1346. fi
  1347. # Configuración SSL/TLS
  1348. # Generar certificados
  1349. # Configurar certificados
  1350. if [ $sslOn = true ];then
  1351. echo -en "Configurando SSL/TLS..." | tee -a $logFile
  1352. # {
  1353. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1354. sleep 2
  1355. progreso=$((progreso + 1))
  1356. # } > >(whiptail --gauge "Configurando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1357. echo -en " OK.\n" | tee -a $logFile
  1358. fi
  1359. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  1360. # {
  1361. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1362. if [ $apacheOn = true ];then
  1363. habilitarServicio $webServerName
  1364. elif [ $nginxOn = true ];then
  1365. habilitarServicio $webServerName
  1366. if [ $phpOn = true ];then
  1367. habilitarServicio $phpFPMName
  1368. fi
  1369. fi
  1370. progreso=$((progreso + 1))
  1371. # } > >(whiptail --gauge "Arrancando Servicios..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1372. # MediaWiki
  1373. if [ $mediaWikiOn = true ]; then
  1374. # Descargar MediaWiki
  1375. echo -en "Descargando MediaWiki-1.31.0..." | tee -a $logFile
  1376. # {
  1377. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1378. descargarMediaWiki
  1379. progreso=$((progreso + 1))
  1380. # } > >(whiptail --gauge "Instalando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1381. echo -en " OK.\n" | tee -a $logFile
  1382. # Configurar MediWiki
  1383. echo -en "Configurando MediaWiki..." | tee -a $logFile
  1384. # {
  1385. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1386. configurarMediaWiki
  1387. progreso=$((progreso + 1))
  1388. # } > >(whiptail --gauge "Configurando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1389. echo -en " OK.\n" | tee -a $logFile
  1390. fi
  1391. # Moodle
  1392. if [ $moodleOn = true ]; then
  1393. # Descargar Moodle
  1394. echo -en "Descargando Moodle-3.5.1..." | tee -a $logFile
  1395. # {
  1396. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1397. descargarMoodle
  1398. progreso=$((progreso + 1))
  1399. # } > >(whiptail --gauge "Instalando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1400. echo -en " OK.\n" | tee -a $logFile
  1401. # Configuración Moodle
  1402. echo -en "Configurando Moodle..." | tee -a $logFile
  1403. # {
  1404. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1405. sleep 2
  1406. progreso=$((progreso + 1))
  1407. # } > >(whiptail --gauge "Configurando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1408. echo -en " OK.\n" | tee -a $logFile
  1409. fi
  1410. # Configurar Virtual Hosts
  1411. # Instalar info.php
  1412. if [ $infoPHPOn = true ];then
  1413. echo -en "Configurando 'info.php'..." | tee -a $logFile
  1414. instalarPHPInfo
  1415. if [ $? -eq 0 ];then
  1416. echo -en " OK.\n" | tee -a $logFile
  1417. else
  1418. echo -en " Ya se encuentra configurado.\n" | tee -a $logFile
  1419. fi
  1420. fi
  1421. # Añadir reglas del cortafuegos
  1422. echo -en "Configurando Cortafuegos..." | tee -a $logFile
  1423. # {
  1424. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1425. configurarCortafuegos
  1426. progreso=$((progreso + 1))
  1427. # } > >(whiptail --gauge "Configurando Cortafuegos..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1428. echo -en " OK.\n" | tee -a $logFile
  1429. # Configurar actualizaciones
  1430. if [ $actualizacionesOn = true ]; then
  1431. echo -en "Configurando Actualizaciones Automáticas..." | tee -a $logFile
  1432. # {
  1433. # echo -en "%s\n" $((100 * progreso / progresoTotal))
  1434. sleep 2
  1435. progreso=$((progreso + 1))
  1436. # } > >(whiptail --gauge "Configurando actualizaciones automáticas..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  1437. echo -en " OK.\n" | tee -a $logFile
  1438. fi